## from ARGB in http://labs.trolltech.com/page/Graphics/Examples/Examples1

import sys
from PyQt4 import QtGui, QtCore, QtSvg


class Widget( QtGui.QWidget ) :

    def __init__( self ):
        QtGui.QWidget.__init__( self, None, QtCore.Qt.FramelessWindowHint )
        self.icon = QtGui.QPixmap("internet.png")
        self.dirty = True
        self.iconShown = False
        self.cache = QtGui.QPixmap()

        # To optimize painting a bit you can set the following:
        # note that child widgets might not be composed
        # correctly then though
        ##self.setAttribute( QtCore.Qt.WA_PaintOnScreen )
        ##self.setAttribute( QtCore.Qt.WA_NoSystemBackground )

        self.renderer = QtSvg.QSvgRenderer( "hummingbird.svg", self )
        self.cbox = QtGui.QCheckBox( "Show icon", self )

        self.connect( self.cbox, QtCore.SIGNAL("toggled(bool)"), 
                      self.showIcon )

    def showIcon( self, value ):
        print 'iconShown', value
        if self.iconShown != value:
            self.iconShown = value
            self.update()

    def paintEvent( self, e ):
        r = e.rect()
        print 'paintEvent', 'e.rect:', (r.x(),r.y(),r.width(),r.height())
        p = QtGui.QPainter( self )
        p.setRenderHint( QtGui.QPainter.Antialiasing )
        p.setClipRect( e.rect() )

        # make sure you clean your widget with a transparent
        # color before doing any rendering
        # note the usage of a composition mode Source
        # it's important!

        p.save()
        p.setCompositionMode( QtGui.QPainter.CompositionMode_Source )
        p.fillRect( self.rect(), QtCore.Qt.transparent )
        p.restore()

        if self.dirty:
            self.cache.fill( QtCore.Qt.transparent )
            cp = QtGui.QPainter( self.cache )
            cp.setRenderHint( QtGui.QPainter.Antialiasing )
            self.renderer.render( cp )
            cp.end()
            self.dirty = False

        p.drawPixmap( 0, 0, self.cache )
        if self.iconShown:
            p.drawPixmap( 20, 20, self.icon )

    def resizeEvent( self, e ):
        print 'resizeEvent', (e.size().width(), e.size().height())
        if e.size() != self.cache.size():
            self.cache = QtGui.QPixmap( e.size() )
            self.dirty = True
            w = e.size().width()
            h = e.size().height()
            self.cbox.setGeometry( w/2 - 50, h - 70, 100, 20 )
        

if __name__ == '__main__':

    app = QtGui.QApplication(sys.argv)

    widget = Widget()

    widget.show()

    app.exec_()
